Index: issm/trunk/src/c/solutions/balancedthickness_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedthickness_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/balancedthickness_core.cpp	(revision 4055)
@@ -12,60 +12,30 @@
 #include "../solvers/solvers.h"
 
-Results* balancedthickness_core(Model* model){
+void balancedthickness_core(FemModel* femmodel){
 
-	extern int my_rank;
+	/*parameters: */
+	int verbose=0;
+	int dim;
 
-	/*output: */
-	Results* results=NULL;
-	Result* result=NULL;
-
-	/*intermediary: */
-	Vec u_g=NULL;
-
-	/*solutions: */
-	Vec h_g=NULL;
-
-	/*flags: */
-	int verbose=0;
-	int numberofdofspernode;
-	int numberofnodes;
-	int dofs[2]={1,1};
-
-	/*fem balancedthickness model: */
-	FemModel* fem_p=NULL;
-
-	//initialize results:
-	results=new Results();
-
-	/*recover fem model: */
-	fem_p=model->GetFormulation(BalancedthicknessAnalysisEnum);
-
-	//first recover parameters common to all solutions
-	model->FindParam(&verbose,VerboseEnum);
-	model->FindParam(&numberofnodes,NumberOfNodesEnum);
-	model->FindParam(&numberofdofspernode,NumberOfDofsPerNodeEnum);
+	/*activate formulation: */
+	femmodel->SetCurrentAnalysis(BalancedthicknessAnalysisEnum);
+	
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
+	femmodel->parameters->FindParam(&dim,DimEnum);
 
 	_printf_("depth averaging velocity...\n");
-	//u_g=inputs->Get("velocity",&dofs[0],2); //take (vx,vy) from inputs velocity
-	//FieldDepthAveragex( u_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"velocity");
-	//inputs->Add("velocity_average",u_g,2,numberofnodes);
-	ISSMERROR("not supported yet!");
-	
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VxEnum);
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VyEnum);
+	if(dim==3) DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VzEnum);
+
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,BalancedthicknessAnalysisEnum,NoneAnalysisEnum);
+	solver_linear(NULL,femmodel);
 
 	_printf_("extrude computed thickness on all layers:\n");
-	FieldExtrudex( h_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"thickness",0);
+	ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,ThicknessEnum);
 
-	/*Plug results into output dataset: */
-	InputToResultx(&result,fem_p->elements,fem_p->nodes,fem_p->vertices, fem_p->loads, fem_p->materials,fem_p->parameters,ThicknessEnum,results->Size()+1,0,1); results->AddObject(result);
-	results->AddObject(new StringResult(results->Size()+1,AnalysisTypeEnum,0,1,EnumAsString(BalancedthicknessAnalysisEnum)));
-
-	/*Free ressources:*/
-	VecFree(&u_g);
-	VecFree(&h_g);
-	
-	/*return: */
-	return results;
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
 
 }
Index: issm/trunk/src/c/solutions/balancedvelocities.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/balancedvelocities.cpp	(revision 4055)
@@ -23,16 +23,10 @@
 	char* inputfilename=NULL;
 	char* outputfilename=NULL;
+	bool   qmu_analysis;
 	char* lockname=NULL;
-	int   numberofnodes;
 	bool  waitonlock=false;
 
-	Model* model=NULL;
-
-	bool   qmu_analysis;
-
-	/*Results: */
-	Results* results=NULL;
-	Result*  result=NULL;
-	Param*   param=NULL;
+	/*FemModel: */
+	FemModel* femmodel=NULL;
 
 	/*time*/
@@ -40,4 +34,7 @@
 	double   start_core, finish_core;
 	double   start_init, finish_init;
+
+	int analyses[1]={BalancedvelocitiesAnalysisEnum};
+	int solution_type=BalancedvelocitiesAnalysisEnum;
 
 	MODULEBOOT();
@@ -66,13 +63,14 @@
 	fid=pfopen(inputfilename,"rb");
 
-	/*Initialize model structure: */
-	model=new Model();
+	_printf_("create finite element model:\n");
+	femmodel=new FemModel(fid,solution_type,analyses,1);
 
-	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,BalancedvelocitiesAnalysisEnum);
-
-	/*recover parameters: */
-	model->FindParam(&waitonlock,WaitOnLockEnum);
-	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename);
+	
+	/*get parameters: */
+	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	femmodel->parameters->FindParam(&control_analysis,ControlAnalysisEnum);
+	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
@@ -84,6 +82,9 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		results=balancedvelocities_core(model);
+		balancedvelocities_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
+
+		_printf_("write results to disk:\n");
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
 
 	}
@@ -95,5 +96,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,BalancedvelocitiesAnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,BalancedvelocitiesAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -101,7 +102,4 @@
 		#endif
 	}
-
-	_printf_("write results to disk:\n");
-	OutputResults(results,outputfilename);
 
 	if (waitonlock>0){
@@ -111,6 +109,5 @@
 
 	/*Free ressources:*/
-	delete results;
-	delete model;
+	delete femmodel;
 
 	/*Get finish time and close*/
Index: issm/trunk/src/c/solutions/balancedvelocities_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/balancedvelocities_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/balancedvelocities_core.cpp	(revision 4055)
@@ -11,60 +11,32 @@
 #include "../solvers/solvers.h"
 
-Results* balancedvelocities_core(Model* model){
-
-	extern int my_rank;
-
-	/*output: */
-	Results* results=NULL;
-	Result* result=NULL;
-
-	/*intermediary: */
-	Vec u_g=NULL;
-
-	/*solutions: */
-	Vec v_g=NULL;
+void balancedvelocities_core(FemModel* femmodel){
 
 	/*flags: */
 	int verbose=0;
-	int numberofdofspernode;
-	int numberofnodes;
-	int dofs[2]={1,1};
+	int dim;
 
-	/*fem balancedvelocities model: */
-	FemModel* fem_p=NULL;
-
-	//initialize results:
-	results=new Results();
-
-	/*recover fem model: */
-	fem_p=model->GetFormulation(BalancedvelocitiesAnalysisEnum);
-
-	//first recover parameters common to all solutions
-	model->FindParam(&verbose,VerboseEnum);
-	model->FindParam(&numberofnodes,NumberOfNodesEnum);
-	model->FindParam(&numberofdofspernode,NumberOfDofsPerNodeEnum);
+	/*activate formulation: */
+	femmodel->SetCurrentAnalysis(BalancedvelocitiesAnalysisEnum);
+	
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
+	femmodel->parameters->FindParam(&dim,DimEnum);
 
 	_printf_("depth averaging velocity...\n");
-	//u_g=inputs->Get("velocity",&dofs[0],2); //take (vx,vy) from inputs velocity
-	//FieldDepthAveragex( u_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"velocity");
-	//inputs->Add("velocity_average",u_g,2,numberofnodes);
-	ISSMERROR(" not supported yet!");
-	
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VxEnum);
+	DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VyEnum);
+	if(dim==3) DepthAverageInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VzEnum);
+
 	_printf_("call computational core:\n");
-	diagnostic_core_linear(&v_g,fem_p,BalancedvelocitiesAnalysisEnum,NoneAnalysisEnum);
+	solver_linear(NULL,femmodel);
 
-	_printf_("extrude computed thickness on all layers:\n");
-	FieldExtrudex( v_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"thickness",0);
+	_printf_("extrude computed velocity on all layers:\n");
+	ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VxEnum);
+	ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,VyEnum);
 
-	/*Plug results into output dataset: */
-	InputToResultx(&result,fem_p->elements,fem_p->nodes,fem_p->vertices, fem_p->loads, fem_p->materials,fem_p->parameters,VxEnum,results->Size()+1,0,1); results->AddObject(result);
-	InputToResultx(&result,fem_p->elements,fem_p->nodes,fem_p->vertices, fem_p->loads, fem_p->materials,fem_p->parameters,VyEnum,results->Size()+1,0,1); results->AddObject(result);
-	results->AddObject(new StringResult(results->Size()+1,AnalysisTypeEnum,0,1,EnumAsString(BalancedvelocitiesAnalysisEnum)));
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VxEnum);
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,VyEnum);
 
-	/*Free ressources:*/
-	VecFree(&u_g);
-	VecFree(&v_g);
-
-	/*return: */
-	return results;
 }
Index: issm/trunk/src/c/solutions/bedslope.cpp
===================================================================
--- issm/trunk/src/c/solutions/bedslope.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/bedslope.cpp	(revision 4055)
@@ -37,6 +37,6 @@
 	double   start_init, finish_init;
 
-	int analyses[1]={BedSlopeComputeAnalysisEnum};
-	int solution_type=BedSlopeComputeSolutionEnum;
+	int analyses[1]={SlopeAnalysisEnum};
+	int solution_type=SlopeAnalysisEnum;
 
 	MODULEBOOT();
@@ -67,4 +67,7 @@
 	_printf_("create finite element model, using analyses types statically defined above:\n");
 	femmodel=new FemModel(fid,solution_type,analyses,1);
+
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 	
 	/*get parameters: */
@@ -83,5 +86,5 @@
 
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel,outputfilename,DiagnosticAnalysisEnum);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 	}
 	else{
@@ -92,5 +95,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(femmodel,SlopeComputeAnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,BedSlopeAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
Index: issm/trunk/src/c/solutions/bedslope_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/bedslope_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/bedslope_core.cpp	(revision 4055)
@@ -25,12 +25,19 @@
 
 	/*Call on core computations: */
-	solver_linear(NULL,femmodel,SlopeComputeAnalysisEnum,BedSlopeXAnalysisEnum);
-	solver_linear(NULL,femmodel,SlopeComputeAnalysisEnum,BedSlopeYAnalysisEnum);
+	femmodel->SetCurrentAnalysisAlias(SlopeAnalysisEnum,BedSlopeXAnalysisEnum);
+	solver_linear(NULL,femmodel);
+	femmodel->SetCurrentAnalysisAlias(SlopeAnalysisEnum,BedSlopeYAnalysisEnum);
+	solver_linear(NULL,femmodel);
 	
 	/*extrude inputs if we are in 3D: */
 	if (dim==3){
-		if(verbose)_printf_("%s\n","extruding slope in 3d...");
-		InputsExtrudex( femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedSlopeXEnum,0);
-		InputsExtrudex( femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedSlopeYEnum,0);
+		if(verbose)_printf_("%s\n","extruding bed in 3d...");
+		ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,BedSlopeXEnum);
+		ExtrudeInputx(femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters,BedSlopeYEnum);
 	}
+	
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedSlopeXEnum);
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,BedSlopeYEnum);
+
 }
Index: issm/trunk/src/c/solutions/control_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/control_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/control_core.cpp	(revision 4055)
@@ -104,5 +104,5 @@
 		if (((n+1)%5)==0){
 			_printf_("%s","      saving temporary results...");
-			controlrestart(femmodel);
+			controlrestart(femmodel,J);
 		}
 	}
Index: issm/trunk/src/c/solutions/controlrestart.cpp
===================================================================
--- issm/trunk/src/c/solutions/controlrestart.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/controlrestart.cpp	(revision 4055)
@@ -7,20 +7,20 @@
 #include "../EnumDefinitions/EnumDefinitions.h"
 
-void controlrestart(FemModel* femmodel){
+void controlrestart(FemModel* femmodel,double* J){
 
-	char*    outputfilename=NULL;
-	
+	int      control_type;
+	int      nsteps;
+
 	/*retrieve output file name: */
-	model->FindParam(&outputfilename,OutputFileNameEnum);
+	femmodel->parameters->FindParam(&control_type,ControlTypeEnum);
+	femmodel->parameters->FindParam(&nsteps,NStepsEnum);
 
 	/*we essentially want J and the parameter: */
 	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,control_type); //the parameter itself!
-	femmodel->otherresults->AddObject(new DoubleResult(femmodel->otherresults->Size()+1,0,1,"J",J,nsteps));
-	femmodel->otherresults->AddObject(new StringResult(results->Size()+1,ControlTypeEnum,0,1,EnumAsString(control_type)));
+	femmodel->results->AddObject(new DoubleVecExternalResult(femmodel->results->Size()+1,JEnum,J,nsteps,1,0));
+	femmodel->results->AddObject(new StringExternalResult(femmodel->results->Size()+1,ControlTypeEnum,EnumAsString(control_type),1,0));
 
 	/*write to disk: */
-	OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
-	
-	/*Free ressources:*/
-	xfree((void**)&outputfilename);
+	OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
+
 }
Index: issm/trunk/src/c/solutions/diagnostic.cpp
===================================================================
--- issm/trunk/src/c/solutions/diagnostic.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/diagnostic.cpp	(revision 4055)
@@ -36,5 +36,5 @@
 	double   start_init, finish_init;
 
-	int analyses[5]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeComputeAnalysisEnum};
+	int analyses[5]={DiagnosticHorizAnalysisEnum,DiagnosticVertAnalysisEnum,DiagnosticStokesAnalysisEnum,DiagnosticHutterAnalysisEnum,SlopeAnalysisEnum};
 	int solution_type=DiagnosticAnalysisEnum;
 
@@ -58,5 +58,4 @@
 	lockname=argv[4];
 
-	/*Initialize femmodel structure: */
 	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
 
@@ -66,4 +65,7 @@
 	_printf_("create finite element model:\n");
 	femmodel=new FemModel(fid,solution_type,analyses,5);
+
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 	
 	/*get parameters: */
@@ -94,5 +96,5 @@
 
 		_printf_("write results to disk:\n");
-		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters, outputfilename);
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 	}
 	else{
Index: issm/trunk/src/c/solutions/diagnostic_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/diagnostic_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/diagnostic_core.cpp	(revision 4055)
@@ -22,6 +22,8 @@
 	bool isstokes=false;
 	double stokesreconditioning;
+	bool conserve_loads=true;
+	bool modify_loads=true;
 
-	/* recover parameters: {{{1*/
+	/* recover parameters:*/
 	femmodel->parameters->FindParam(&verbose,VerboseEnum);
 	femmodel->parameters->FindParam(&dim,DimEnum);
@@ -31,5 +33,4 @@
 	femmodel->parameters->FindParam(&stokesreconditioning,StokesReconditioningEnum);
 	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	/*}}}*/
 
 	/*for qmu analysis, reinitialize velocity so that fake sensitivities do not show up as a result of a different restart of the convergence at each trial.*/
@@ -48,5 +49,6 @@
 			
 		if(verbose)_printf_("%s\n"," computing hutter velocities...");
-		solver_linear(NULL,femmodel,DiagnosticAnalysisEnum,HutterAnalysisEnum); 
+		femmodel->SetCurrentAnalysis(DiagnosticHutterAnalysisEnum);
+		solver_linear(NULL,femmodel);
 		
 		if (ismacayealpattyn) ResetBoundaryConditions(femmodel,DiagnosticAnalysisEnum,HorizAnalysisEnum);
@@ -56,5 +58,6 @@
 		
 		if(verbose)_printf_("%s\n"," computing horizontal velocities...");
-		solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,false,DiagnosticAnalysisEnum,HorizAnalysisEnum); //false means we expose loads to changes inside the solution
+		femmodel->SetCurrentAnalysis(DiagnosticHorizAnalysisEnum);
+		solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,modify_loads); 
 	}
 	
@@ -63,5 +66,6 @@
 
 		if(verbose)_printf_("%s\n"," computing vertical velocities...");
-		solver_linear(NULL,femmodel,DiagnosticAnalysisEnum,VertAnalysisEnum);
+		femmodel->SetCurrentAnalysis(DiagnosticVertAnalysisEnum);
+		solver_linear(NULL,femmodel);
 
 		if (isstokes){
@@ -75,5 +79,6 @@
 
 			if(verbose)_printf_("%s\n"," computing stokes velocities and pressure ...");
-			solver_diagnostic_nonlinear(NULL,NULL,NULL,NULL,femmodel,DiagnosticAnalysisEnum,StokesAnalysisEnum);
+			femmodel->SetCurrentAnalysis(DiagnosticStokesAnalysisEnum);
+			solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,conserve_loads);
 		}
 	}
Index: issm/trunk/src/c/solutions/gradient_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/gradient_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/gradient_core.cpp	(revision 4055)
@@ -32,10 +32,10 @@
 	
 	if(verbose)_printf_("%s\n","      compute gradient:");
-	Gradjx(&gradient, femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters, control_type,AdjointEnum);
+	Gradjx(&gradient, femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters, control_type);
 	
 	if(verbose)_printf_("%s\n","      retrieve old gradient:");
 	GetVectorFromInputsx(&old_gradient, femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials,femmodel->parameters, OldGradientEnum,VertexEnum);
 
-	if(control_steady)diagnostic_core(model);
+	if(control_steady)diagnostic_core(femmodel);
 	
 	if (step>0 && search_scalar==0){
@@ -55,6 +55,6 @@
 
 	/*plug back into inputs: */
-	UpdateInputsFromVectorx( femmodel-> elements,femmodel-> nodes, femmodel-> vertices,femmodel-> loads, femmodel-> materials,  femmoel->parameters,gradient,GradientEnum,VertexEnum);
-	UpdateInputsFromVectorx( femmodel-> elements,femmodel-> nodes, femmodel-> vertices,femmodel-> loads, femmodel-> materials,  femmoel->parameters,old_gradient,OldGradientEnum,VertexEnum);
+	UpdateInputsFromVectorx( femmodel-> elements,femmodel-> nodes, femmodel-> vertices,femmodel-> loads, femmodel-> materials,  femmodel->parameters,gradient,GradientEnum,VertexEnum);
+	UpdateInputsFromVectorx( femmodel-> elements,femmodel-> nodes, femmodel-> vertices,femmodel-> loads, femmodel-> materials,  femmodel->parameters,old_gradient,OldGradientEnum,VertexEnum);
 
 	/*Free ressources and return:*/
Index: issm/trunk/src/c/solutions/objectivefunctionC.cpp
===================================================================
--- issm/trunk/src/c/solutions/objectivefunctionC.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/objectivefunctionC.cpp	(revision 4055)
@@ -3,8 +3,5 @@
  */ 
 
-#include "../modules/modules.h"
-#include "./solutions.h"
-#include "../EnumDefinitions/EnumDefinitions.h"
-
+/*include files: {{{1*/
 #ifdef HAVE_CONFIG_H
 	#include "config.h"
@@ -12,4 +9,14 @@
 #error "Cannot compile with HAVE_CONFIG_H symbol! run configure first!"
 #endif
+
+#include "../toolkits/toolkits.h"
+#include "../objects/objects.h"
+#include "../shared/shared.h"
+#include "../EnumDefinitions/EnumDefinitions.h"
+#include "../solvers/solvers.h"
+#include "./solutions.h"
+#include "../modules/modules.h"
+#include "../include/include.h"
+/*}}}*/
 
 double objectivefunctionC(double search_scalar,OptArgs* optargs){
@@ -22,5 +29,5 @@
 	/*parameters: */
 	FemModel* femmodel=NULL;
-	int n;
+	int     n;
 	double* optscal=NULL;
 	double* fit=NULL;
@@ -29,7 +36,7 @@
 	int     control_type;
 	int     analysis_type;
-	int     sub_analysis_type;
 	int     control_steady;
-		
+	bool    conserve_loads=true;
+	
 	/*Recover finite element model: */
 	femmodel=optargs->femmodel;
@@ -45,5 +52,4 @@
 	femmodel->parameters->FindParam(&control_steady,ControlSteadyEnum);
 	femmodel->parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-	femmodel->parameters->FindParam(&sub_analysis_type,SubAnalysisTypeEnum);
 
 	/*Use ControlParameterEnum input to  reinitialize our input parameter: */
@@ -57,10 +63,10 @@
 
 	/*Run diagnostic with updated inputs: */
-	if(!control_steady) solver_diagnostic_nonlinear(NULL,NULL,NULL,true,femmodel,DiagnosticAnalysisEnum,sub_analysis_type);  //true means we conserve loads at each diagnostic run
+	if(!control_steady) solver_diagnostic_nonlinear(NULL,NULL,NULL,femmodel,conserve_loads);  //true means we conserve loads at each diagnostic run
 	else                diagnostic_core(femmodel);	//We need a 3D velocity!! (vz is required for the next thermal run)
 
 	/*Compute misfit for this velocity field.*/
 	UpdateInputsFromConstantx( femmodel->elements,femmodel->nodes, femmodel->vertices, femmodel->loads, femmodel->materials, femmodel->parameters,fit[n],FitEnum);
-	CostFunctionx( &J, femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters,analysis_type,sub_analysis_type);
+	CostFunctionx( &J, femmodel->elements,femmodel->nodes, femmodel->vertices,femmodel->loads, femmodel->materials, femmodel->parameters);
 
 	/*Free ressources:*/
Index: issm/trunk/src/c/solutions/prognostic.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/prognostic.cpp	(revision 4055)
@@ -24,15 +24,9 @@
 	char* outputfilename=NULL;
 	char* lockname=NULL;
-	int   numberofnodes;
+	bool  qmu_analysis=false;
 	bool  waitonlock=false;
 
-	Model* model=NULL;
-
-	bool qmu_analysis;
-
-	/*Results: */
-	Results* results=NULL;
-
-	Param*   param=NULL;
+	/*FemModel: */
+	FemModel* femmodel=NULL;
 
 	/*time*/
@@ -40,4 +34,7 @@
 	double   start_core, finish_core;
 	double   start_init, finish_init;
+
+	int analyses[1]={PrognosticAnalysisEnum};
+	int solution_type=PrognosticAnalysisEnum;
 
 	MODULEBOOT();
@@ -62,15 +59,18 @@
 	/*Initialize model structure: */
 	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
-	model=new Model();
 
 	/*Open handle to data on disk: */
 	fid=pfopen(inputfilename,"rb");
 
-	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,PrognosticAnalysisEnum);
+	_printf_("create finite element model:\n");
+	femmodel=new FemModel(fid,solution_type,analyses,1);
 
-	/*recover parameters: */
-	model->FindParam(&waitonlock,WaitOnLockEnum);
-	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
+
+	/*get parameters: */
+	femmodel->parameters->FindParam(&qmu_analysis,QmuAnalysisEnum);
+	femmodel->parameters->FindParam(&waitonlock,WaitOnLockEnum);
+
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
@@ -82,6 +82,9 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		results=prognostic_core(model);
+		prognostic_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
+		
+		_printf_("write results to disk:\n");
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 
 	}
@@ -93,5 +96,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,PrognosticAnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,PrognosticAnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -101,7 +104,4 @@
 
 		
-	_printf_("write results to disk:\n");
-	OutputResults(results,outputfilename);
-
 	if (waitonlock>0){
 		_printf_("write lock file:\n");
@@ -110,6 +110,5 @@
 
 	/*Free ressources:*/
-	delete results;
-	delete model;
+	delete femmodel;
 
 	/*Get finish time and close*/
Index: issm/trunk/src/c/solutions/prognostic2.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic2.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/prognostic2.cpp	(revision 4055)
@@ -24,15 +24,9 @@
 	char* outputfilename=NULL;
 	char* lockname=NULL;
-	int   numberofnodes;
+	bool  qmu_analysis=false;
 	bool  waitonlock=false;
 
-	Model* model=NULL;
-
-	bool   qmu_analysis;
-
-	/*Results: */
-	Results* results=NULL;
-
-	Param*   param=NULL;
+	/*FemModel: */
+	FemModel* femmodel=NULL;
 
 	/*time*/
@@ -40,4 +34,7 @@
 	double   start_core, finish_core;
 	double   start_init, finish_init;
+
+	int analyses[1]={Prognostic2AnalysisEnum};
+	int solution_type=Prognosti2cAnalysisEnum;
 
 	MODULEBOOT();
@@ -62,16 +59,18 @@
 	/*Initialize model structure: */
 	MPI_Barrier(MPI_COMM_WORLD); start_init=MPI_Wtime();
-	model=new Model();
 
 	/*Open handle to data on disk: */
 	fid=pfopen(inputfilename,"rb");
 
-	_printf_("read and create finite element model:\n");
-	model->AddFormulation(fid,Prognostic2AnalysisEnum);
+	_printf_("create finite element model:\n");
+	femmodel=new FemModel(fid,solution_type,analyses,1);
+
+	/*add outputfilename in parameters: */
+	femmodel->parameters->AddObject(new StringParam(OutputFileNameEnum,outputfilename));
 
 	/*recover parameters: */
 	model->FindParam(&waitonlock,WaitOnLockEnum);
 	model->FindParam(&qmu_analysis,QmuAnalysisEnum);
-	model->FindParam(&numberofnodes,NumberOfNodesEnum);
+
 
 	MPI_Barrier(MPI_COMM_WORLD); finish_init=MPI_Wtime();
@@ -83,6 +82,9 @@
 		_printf_("call computational core:\n");
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		results=prognostic2_core(model);
+		prognostic2_core(femmodel);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
+
+		_printf_("write results to disk:\n");
+		OutputResults(femmodel->elements, femmodel->loads, femmodel->nodes, femmodel->vertices, femmodel->materials, femmodel->parameters);
 
 	}
@@ -94,5 +96,5 @@
 		#ifdef _HAVE_DAKOTA_ 
 		MPI_Barrier(MPI_COMM_WORLD); start_core=MPI_Wtime( );
-		Qmux(model,Prognostic2AnalysisEnum,NoneAnalysisEnum);
+		Qmux(femmodel,Prognostic2AnalysisEnum,NoneAnalysisEnum);
 		MPI_Barrier(MPI_COMM_WORLD); finish_core=MPI_Wtime( );
 	 	#else
@@ -100,7 +102,4 @@
 		#endif
 	}
-
-	_printf_("write results to disk:\n");
-	OutputResults(results,outputfilename);
 
 	if (waitonlock>0){
@@ -110,6 +109,5 @@
 
 	/*Free ressources:*/
-	delete results;
-	delete model;
+	delete femmodel;
 
 	/*Get finish time and close*/
Index: issm/trunk/src/c/solutions/prognostic2_core.cpp
===================================================================
--- issm/trunk/src/c/solutions/prognostic2_core.cpp	(revision 4054)
+++ issm/trunk/src/c/solutions/prognostic2_core.cpp	(revision 4055)
@@ -11,64 +11,29 @@
 #include "../solvers/solvers.h"
 
-Results* prognostic2_core(Model* model){
-
-	extern int my_rank;
-
-	/*output: */
-	Results* results=NULL;
-	Result* result=NULL;
-
-	/*intermediary: */
-	Vec vx_g=NULL;
-	Vec vy_g=NULL;
-
-	/*solutions: */
-	Vec h_g=NULL;
+void prognostic2_core(FemModel* femmodel){
 
 	/*flags: */
 	int verbose=0;
-	int numberofdofspernode;
-	int numberofnodes;
-	int numberofvertices;
-	int dofs[1]={1};
 
-	/*fem prognostic model: */
-	FemModel* fem_p=NULL;
+	/*activate formulation: */
+	femmodel->SetCurrentAnalysis(Prognostic2AnalysisEnum);
 
-	//initialize results:
-	results=new Results();
-
-	/*recover fem model: */
-	fem_p=model->GetFormulation(Prognostic2AnalysisEnum);
-
-	//first recover parameters common to all solutions
-	model->FindParam(&verbose,VerboseEnum);
-	model->FindParam(&numberofnodes,NumberOfNodesEnum);
-	model->FindParam(&numberofvertices,NumberOfVerticesEnum);
-	model->FindParam(&numberofdofspernode,NumberOfNodesEnum);
+	/*recover parameters: */
+	femmodel->parameters->FindParam(&verbose,VerboseEnum);
 
 	_printf_("depth averaging velocity...\n");
 	/*Where is it done?*/
+
+	_printf_("call computational core:\n");
+	solver_linear(NULL,femmodel);
 	
-	_printf_("call computational core:\n");
-	diagnostic_core_linear(&h_g,fem_p,Prognostic2AnalysisEnum,NoneAnalysisEnum);
-
 	_printf_("Averaging over vertices:\n");
-	FieldAverageOntoVerticesx(&h_g,fem_p->elements,fem_p->nodes,fem_p->vertices,fem_p->loads,fem_p->materials,fem_p->parameters);
+	//FieldAverageOntoVerticesx(&h_g,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters);
 
 	//_printf_("extrude computed thickness on all layers:\n");
 	//FieldExtrudex(h_g, fem_p->elements,fem_p->nodes, fem_p->vertices,fem_p->loads, fem_p->materials,fem_p->parameters,"thickness",0);
 
-	/*Plug results into output dataset: */
-	InputToResultx(&result,fem_p->elements,fem_p->nodes,fem_p->vertices, fem_p->loads, fem_p->materials,fem_p->parameters,ThicknessEnum,results->Size()+1,0,1); results->AddObject(result);
-	results->AddObject(new StringResult(results->Size()+1,AnalysisTypeEnum,0,1,EnumAsString(Prognostic2AnalysisEnum)));
-
-	/*Free ressources:*/
-	VecFree(&vx_g);
-	VecFree(&vy_g);
-	VecFree(&h_g);
-	
-	/*return: */
-	return results;
+	if(verbose)_printf_("saving results:\n");
+	InputToResultx(femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,ThicknessEnum);
 
 }
